"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = buildMediaQuery;

function buildMediaQuery(screens) {
  if (typeof screens === 'string') {
    screens = {
      min: screens
    };
  }

  if (!Array.isArray(screens)) {
    screens = [screens];
  }

  return screens.map(screen => {
    var _screen$hasOwnPropert;

    if (screen !== null && screen !== void 0 && (_screen$hasOwnPropert = screen.hasOwnProperty) !== null && _screen$hasOwnPropert !== void 0 && _screen$hasOwnPropert.call(screen, 'raw')) {
      return screen.raw;
    }

    return Object.entries(screen).map(([feature, value]) => {
      var _min$max$feature;

      feature = (_min$max$feature = {
        min: 'min-width',
        max: 'max-width'
      }[feature]) !== null && _min$max$feature !== void 0 ? _min$max$feature : feature;
      return `(${feature}: ${value})`;
    }).join(' and ');
  }).join(', ');
}